{-------------------------------------------------------------------------------
Exemple - Extension du menu contextuel d'Internet Explorer
Adrien Montfaucon

- Mises  jour : http://www.phidels.com / http://admon.free.fr

- Erreurs, Questions, suggestions : am-vector@laposte.net
-------------------------------------------------------------------------------}

unit MyDownload_Sys;

{-------------------------------------------------------------------------------
Extension du menu contextuel d'Internet Explorer

Unit principale du programme rsident
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MyDownload_CommonConsts; //Ne pas oublier l'unit de constantes

type
  TWMyDownload = class(TForm)
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ShowNewDownload(URL, Title: String);
  private
    { Dclarations prives }
  public
    procedure DefaultHandler(var Msg); override;
  end;

var
  WMyDownload: TWMyDownload;
  URLMsg: Cardinal;

implementation

{$R *.dfm}

{ TWMyDownload }

procedure TWMyDownload.FormCreate(Sender: TObject);
begin
URLMsg:=RegisterWindowMessage(HostMessage);
if ParamCount>1 then
  //Rcupration des donnes dans le cas o le programme n'tait pas actif
  ShowNewDownload(ParamStr(1),ParamStr(2));
end;

procedure TWMyDownload.DefaultHandler(var Msg);
var NewURL, NewTitle: PChar;
begin
inherited;
//Rcupration des donnes dans le cas o le programme tait pas actif
if TMessage(Msg).Msg = URLMsg then
  begin
  //Rcupration des chaines
  GetMem(NewURL, 256);
  GetMem(NewTitle, 256);
  GlobalGetAtomName(TMessage(Msg).WParam, NewURL, 255);
  GlobalGetAtomName(TMessage(Msg).LParam, NewTitle, 255);
  GlobalDeleteAtom(TMessage(Msg).WParam);
  GlobalDeleteAtom(TMessage(Msg).LParam);
  //Supression des caractres de fin de chaine
  ShowNewDownload(NewURL, NewTitle);
  FreeMem(NewURL);
  FreeMem(NewTitle);
  end;
end;

procedure TWMyDownload.ShowNewDownload(URL, Title: String);
begin
//Cette fonction est appelle  chaque demande de tlchargement, les donnes tant en paramtres
//Affichage du tlchargement
ListBox1.Items.Add('>> '+Title+' ('+URL+')');
SetForegroundWindow(Handle);
end;

end.
